********************************************************************************
********************************************************************************
*****                                                                      *****
*****  Programm:         Library.prg                                       *****
*****  Autor             Peter Hegelbach                                   *****
*****  zuletzt gendert: 13.08.2017                                        *****
*****                                                                      *****
********************************************************************************
********************************************************************************

//---------------------------------------------------------------------------------
   Function FDoY( dArg )                  // Fist Day of Year
      local dJan
      dJan = dArg - day( dArg ) + 1 - 28 * ( month( dArg ) - 1)
      Return dJan - day( dJan ) + 1

//---------------------------------------------------------------------------------
   Function LDoM( dDate )     '' LastDayOfMonth
      return  dttod(new date(dDate.year, dDate.month + 1, 1) - 1)

//---------------------------------------------------------------------------------
   function DayBefore6Months( dDate )     // Parameter as Date
      Jahr = year(dDate)
      Monat = month(dDate)-6
      dTag = day(dDate)
      if Monat < 1
         Monat += 12
         Jahr -= 1
      endif
      Dat = ctod(dTag + "." + Monat + "." + Jahr)
      do while Month(Dat) > Monat      // Korretkur, falls 31.2. gerechnet
         Dat -= 1
      enddo
      return Dat

//---------------------------------------------------------------------------------
   function IsLastDayOfMonth( dDate)
      return dDate == dttod(new date(dDate.year, dDate.month + 1, 1) - 1)

//---------------------------------------------------------------------------------
   function LDoY( dArg )
      local dDec
      dDec = dArg - day( dArg ) + 28 * ( 13 - month( dArg ))
      Return LDoM( dDec )

//---------------------------------------------------------------------------------
   function SameDateNextYear( dDate )
      Return new Date(year(dDate)+1, month(dDate)-1, day(dDate))
      	
//---------------------------------------------------------------------------------
   function To_SQL_Date(cDate)
		return year(cDate) + "." + str(month(cDate),2,0,"0") + "." + str(day(cDate),2,0,"0")

//---------------------------------------------------------------------------------
   Function fDoM( dArg )
      // Erster Tag im Monat eines Datums
      Return ( ( dArg ) - day( dArg ) + 1 )

//---------------------------------------------------------------------------------
   Function lDoM( dDate )
      // Letzter Tag im Monat eines Datums
      local dNxtMonth
      dNxtMonth = dDate - day( dDate ) + 45 // middle of next month
      RETURN dNxtMonth - day( dNxtMonth )

//---------------------------------------------------------------------------------
   Function Analyse_TextFilter(Textfeldname, Feld)
   	local Textstring, lUmkehren
      lUmkehren = false
   	Textstring = ltrim(trim(Feld.value))
      if not empty(Textstring)
         res = "(" + Textfeldname

         // Testen auf 'ausschliessen'
         if left(Textstring,1) = "!" 
            lUmkehren = true
            Textstring = ltrim(subst(Textstring, 2, 99))
         endif

         do Case
         // Testen auf NULL-Fall
         Case upper(Textstring) = "NULL" 
            if lUmkehren
	         	res += " <> null"
            else
            	res += " is null"
            endif
         
         // Testen auf Caret  ^
         Case asc(left(Textstring,1)) = 94
            val2 = trim(ltrim(subst(Textstring,2,94)))
            if not empty(val2)
           		if lUmkehren
               	res += " not like '%"+ val2 + "%'"
               else
                  res += " like '%"+ val2 + "%'"
               endif
            endif

         // Testen auf Gleichzeichen  =
         Case asc(left(Textstring,1)) = 61
            val2 = ltrim(subst(Textstring,2,99))
            if not empty(val2)
           		if lUmkehren
               	res += " <> '" + val2 + "'"
               else
                  res += " = '"+ val2 + "'"
               endif
            endif
         
         // Testen auf von/bis  (Doppelpunkt : enthalten)
         Case at(":", Textstring, 1) > 0
            vPos = at(":", Textstring, 1)
            val2 = ltrim(trim(left(Textstring, vPos - 1)))
            val3 = ltrim(trim(subst(Textstring, vPos + 1, 99)))
            if not empty(val2) and not empty(val3)
               if lUmkehren
                  res += " < '" + val2 + "' or "+Textfeldname + " > '" + val3  + "'"
               else
                  res += " >= '" + val2 + "' and "+Textfeldname+ " <= '" + val3 + "'"
               endif
            endif
            

         // Testen auf '>'-Fall
         Case asc(left(Textstring, 1)) = 62
            if asc(subst(Textstring, 2, 1) ) = 61
               val2 = ltrim(subst(Textstring, 3, 99))
               if not empty(val2)
               	if lUmkehren
                  	res += " < '" + val2 + "'"
                  else
                  	res += " >= '" + val2 + "'"
                  endif
               endif
            else
               val2 = ltrim(subst(Textstring, 2, 99))
               if not empty(val2)
               	if lUmkehren
                  	res += " <= '" + val2 + "'"
                  else
                     res += " > '" + val2 + "'"
                  endif
               endif
            endif
         
         // Testen auf '<'-Fall
         Case asc(left(Textstring,1)) = 60
            if asc(subst(Textstring,2,1)) = 61
               val2 = ltrim(subst(Textstring,3,99))
               if not empty(val2)
               	if lUmkehren
                  	res += "> '" + val2 + "'"
						else
                     res += "<= '" + val2 + "'"
                  endif
               endif
            else
               val2 = ltrim(subst(Textstring, 2, 99))
               if not empty(val2)
                  if lUmkehren
                   	res += " >= '" + val2 + "'"
                  else
                     res += " < '" + val2 + "'"
                  endif
               endif
            endif
         otherwise
            val2 = ltrim(subst(Textstring,1,99))
            if not empty(val2)
           		if lUmkehren
               	res += " not like '%"+ val2 + "%'"
               else
                  res += " like '%"+ val2 + "%'"
               endif
            endif
         Endcase

         res += ")"
      else
      	res = ""
      endif
      return(res)     

//---------------------------------------------------------------------------------
   Function Analyse_Datumfilter(Datumfeldname, Feld)
   	local Datumstring, lUmkehren
      lUmkehren = false
   	Datumstring = ltrim(Feld.value)
      if not empty(Datumstring)
         res = "(" + Datumfeldname

         // Testen auf 'ausschliessen'
         if left(Datumstring,1) = "!" 
            lUmkehren = true
            Datumstring = subst(Datumstring, 2, 99)	
         endif

         // Testen auf NULL-Fall
         if upper(Datumstring) = "NULL" 
            if lUmkehren
	         	res += " <> null"
            else
            	res += " is null"
            endif
         endif

         // Testen auf Gleichzeichen
         if asc(left(Datumstring,1)) = 61
            val2 = ctod(ltrim(subst(Datumstring,2,99)))
            if not empty(val2)
           		if lUmkehren
               	res += " <> '"+ val2 + "'"
               else
                  res += " = '"+ val2 + "'"
               endif
            endif
         endif

         // Testen auf entspricht oder von/bis
         if asc(left(Datumstring,1)) >= 48 and asc(left(Datumstring,1)) <= 57
            // erstes Zeichen ist numerisch, also zw. 0 und 9
            vPos = at(":", Datumstring, 1)
            if vPos > 0
               //Doppelpunkt vorhanden, darum von/bis-Fall
               val2 = ctod(left(Datumstring, vPos - 1))
               val3 = ctod(subst(Datumstring, vPos + 1, 99))
               if not empty(val2) and not empty(val3)
               	if lUmkehren
 							res += " < '" + val2 + "' or "+Datumfeldname + " > '" + val2  + "'"
                  else
                  	res += " >= '" + val2 + "' and "+Datumfeldname + " <= '" + val3 + "'"
                  endif
               endif
            else
               // enstpricht-Fall
               val2 = ctod(Datumstring)
               if not empty(val2)
               	if lUmkehren
                  	res += " <> '" + val2 + "'"
                  else
	                  res += " = '" + val2 + "'"
                  endif
               endif
            endif
         endif

         // Testen auf '>'-Fall
         if asc(left(Datumstring, 1)) = 62
            if asc(subst(Datumstring, 2, 1) ) = 61
               val2 = ctod(subst(Datumstring, 3, 99))
               if not empty(val2)
               	if lUmkehren
                  	res += " < '" + val2 + "'"
                  else
                  	res += " >= '" + val2 + "'"
                  endif
               endif
            else
               val2 = ctod(subst(Datumstring, 2, 99)) 
               if not empty(val2)
               	if lUmkehren
                  	res += " <= '" + val2 + "'"
                  else
                     res += " > '" + val2 + "'"
                  endif
               endif
            endif
         endif

         // Testen auf '<'-Fall
         if asc(left(Datumstring,1)) = 60
            if asc(subst(Datumstring,2,1)) = 61
               val2 = ctod(subst(Datumstring,3,99))
               if not empty(val2)
               	if lUmkehren
                  	res += "> '" + val2 + "'"
						else
                     res += "<= '" + val2 + "'"
                  endif
               endif
            else
               val2 = ctod(subst(Datumstring, 2, 99)) 
               if not empty(val2)
                  if lUmkehren
                   	res += " >= '" + val2 + "'"
                  else
                     res += " < '" + val2 + "'"
                  endif
               endif
            endif
         endif 
         res += ")"
      else
      	res = ""
      endif
      return(res)       

//---------------------------------------------------------------------------------
   Function Analyse_NumTextFilter(numTextfeldname, Feld)
   	local Textstring, lUmkehren
      lUmkehren = false
   	Textstring = ltrim(Feld.value)
      if not empty(Textstring)
         res = "(" + numTextfeldname

         // Testen auf 'ausschliessen'
         if left(Textstring,1) = "!" 
         	lUmkehren = true
            Textstring = ltrim(subst(Textstring, 2, 99))
         endif

         // Testen auf NULL-Fall
         if upper(Textstring) = "NULL" 
				if lUmkehren
	            res += " <> null"
				else
	            res += " is null"
            endif
         endif

         // Testen auf Gleichzeichen
         if asc(left(Textstring,1)) = 61
            val2 = val(subst(Textstring,2,99))
            if not empty(val2)
					if lUmkehren
                  res += " <> '"+ ltrim(str(val2)) + "'"
               else
                  res += " = '"+ ltrim(str(val2)) + "'"
               endif
            endif
         endif

         // Testen auf entspricht oder von/bis
         if asc(left(Textstring,1)) >= 48 and asc(left(Textstring,1)) <= 57
            // erstes Zeichen ist numerisch, also zw. 0 und 9
            vPos = at(":", Textstring, 1)
            if vPos > 0
               //Doppelpunkt vorhanden, darum von/bis-Fall
               val2 = val(left(Textstring, vPos - 1))
               val3 = val(subst(Textstring, vPos + 1, 99))
               if not empty(val2) and not empty(val3)
               	if lUmkehren
	                  res += " < '" + ltrim(str(val2)) + "' or "+numTextfeldname + " > '" + ltrim(str(val3)) + "'"
						else
	                  res += " between '" + ltrim(str(val2)) + "' and '" + ltrim(str(val3)) + "'"
                  endif
               endif
            else
               // enstpricht-Fall
               val2 = val(Textstring)
               if not empty(val2)
                  if lUmkehren
                     res += " <> '"+ ltrim(str(val2)) + "'"
                  else
                     res += " = '"+ ltrim(str(val2)) + "'"
                  endif
               endif
            endif
         endif

         // Testen auf '>'-Fall
         if asc(left(Textstring, 1)) = 62
            if asc(subst(Textstring, 2, 1) ) = 61
               val2 = val(subst(Textstring, 3, 99))
               if not empty(val2)
               	if lUmkehren
	                  res += " < '" + ltrim(str(val2)) + "'"
                  else
	                  res += " >= '" + ltrim(str(val2)) + "'"
						endif
               endif
            else
               val2 = val(subst(Textstring, 2, 99)) 
               if not empty(val2)
               	if lUmkehren
	                  res += "<= '" + ltrim(str(val2)) + "'"
                  else
	                  res += "> '" + ltrim(str(val2)) + "'"
                  endif
               endif
            endif
         endif

         // Testen auf '<'-Fall
         if asc(left(Textstring,1)) = 60
            if asc(subst(Textstring,2,1)) = 61
               val2 = val(subst(Textstring,3,99))
               if not empty(val2)
               	if lUmkehren
	                  res += "> '" + ltrim(str(val2)) + "'"
						else
   	               res += "<= '" + ltrim(str(val2)) + "'"
                  endif
               endif
            else
               val2 = val(subst(Textstring, 2, 99)) 
               if not empty(val2)
               	if lUmkehren
	                  res += ">= '" + ltrim(str(val2)) + "'"
						else
   	               res += "< '" + ltrim(str(val2)) + "'"
                  endif
               endif
            endif
         endif 
         res += ")"
      else
      	res = ""
      endif
      return(res)  
		
//---------------------------------------------------------------------------------
   Function Analyse_IntegerFilter(IntegerFeldname, Feld)
   	local Textstring, lUmkehren
      lUmkehren = false
   	Textstring = ltrim(Feld.value)		// ist immer Text, da aus einem Filterfeld, mit Sonderzeichen wie >, >= usw.
      if not empty(Textstring)
         res = "(" + IntegerFeldname

         // Testen auf 'ausschliessen'
         if left(Textstring,1) = "!" 
         	lUmkehren = true
            Textstring = ltrim(subst(Textstring, 2, 99))
         endif

         // Testen auf NULL-Fall
         if upper(Textstring) = "NULL" 
				if lUmkehren
	            res += " <> null"
				else
	            res += " is null"
            endif
         endif

         // Testen auf Gleichzeichen
         if asc(left(Textstring,1)) = 61
            val2 = ltrim(subst(Textstring,2,99))
            if len(val2) > 0
					if lUmkehren
                  res += " <> "+ val2
               else
                  res += " = "+ val2
               endif
            endif
         endif

         // Testen auf entspricht oder von/bis
         if asc(left(Textstring,1)) >= 48 and asc(left(Textstring,1)) <= 57
            // erstes Zeichen ist numerisch, also zw. 0 und 9
            vPos = at(":", Textstring, 1)
            if vPos > 0
               //Doppelpunkt vorhanden, darum von/bis-Fall
               val2 = val(left(Textstring, vPos - 1))
               val3 = val(subst(Textstring, vPos + 1, 99))
               if not empty(val2) and not empty(val3)
               	if lUmkehren
	                  res += " < " + ltrim(str(val2)) + " or "+ IntegerFeldname + " > " + ltrim(str(val3)) 
						else
	                  res += " >= " + ltrim(str(val2)) + " and " + IntegerFeldname + " <= " + ltrim(str(val3)) 
                  endif
               endif
            else
               // enstpricht-Fall
               if len(Textstring) > 0
                  if lUmkehren
                     res += " <> "+ Textstring
                  else
                     res += " = "+ Textstring
                  endif
               endif
            endif
         endif

         // Testen auf '>'-Fall
         if asc(left(Textstring, 1)) = 62
            if asc(subst(Textstring, 2, 1) ) = 61
               val2 = val(subst(Textstring, 3, 99))
               if not empty(val2)
               	if lUmkehren
	                  res += " < " + ltrim(str(val2))
                  else
	                  res += " >= " + ltrim(str(val2))
						endif
               endif
            else
               val2 = val(subst(Textstring, 2, 99)) 
               if not empty(val2)
               	if lUmkehren
	                  res += " <= " + ltrim(str(val2))
                  else
	                  res += " > " + ltrim(str(val2))
                  endif
               endif
            endif
         endif

         // Testen auf '<'-Fall
         if asc(left(Textstring,1)) = 60
            if asc(subst(Textstring,2,1)) = 61
               val2 = val(subst(Textstring,3,99))
               if not empty(val2)
               	if lUmkehren
	                  res += " > " + ltrim(str(val2))
						else
   	               res += " <= " + ltrim(str(val2))
                  endif
               endif
            else
               val2 = val(subst(Textstring, 2, 99)) 
               if not empty(val2)
               	if lUmkehren
	                  res += " >= " + ltrim(str(val2)) 
						else
   	               res += " < " + ltrim(str(val2)) 
                  endif
               endif
            endif
         endif 
         res += ")"
      else
      	res = ""
      endif
      return(res)  		

//---------------------------------------------------------------------------------
   Function Analyse_BetragFilter(BetragFeldname, Feld)
   	local Betragstring, lUmkehren
      lUmkehren = false
   	Betragstring = ltrim(Feld.value)
      if not empty(Betragstring)
         res = "(" + BetragFeldname

         // Testen auf 'ausschliessen'
         if left(Betragstring,1) = "!" 
         	lUmkehren = true
            Betragstring = ltrim(subst(Betragstring, 2, 99))
         endif

         // Testen auf NULL-Fall
         if upper(Betragstring) = "NULL" 
				if lUmkehren
	            res += " <> null"
				else
	            res += " is null"
            endif
         endif

         // Testen auf Gleichzeichen
         if asc(left(Betragstring,1)) = 61
            val2 = val(subst(Betragstring,2,99))
//            if not empty(val2)
					if lUmkehren
                  res += " <> "+ ltrim(str(val2,10,2)) 
               else
                  res += " = "+ ltrim(str(val2,10,2)) 
               endif
//            endif
         endif

         // Testen auf entspricht oder von/bis
         if asc(left(Betragstring,1)) >= 48 and asc(left(Betragstring,1)) <= 57
            // erstes Zeichen ist numerisch, also zw. 0 und 9
            vPos = at(":", Betragstring, 1)
            if vPos > 0
               //Doppelpunkt vorhanden, darum von/bis-Fall
               val2 = val(left(Betragstring, vPos - 1))
               val3 = val(subst(Betragstring, vPos + 1, 99))
               if not empty(val2) and not empty(val3)
               	if lUmkehren
	                  res += " < " + ltrim(str(val2,10,2)) + " or "+BetragFeldname + " > " + ltrim(str(val3,10,2)) 
						else
	                  res += " >= " + ltrim(str(val2,10,2)) + " and "+ BetragFeldname + " <= " + ltrim(str(val3,10,2))
                  endif
               endif
            else
               // enstpricht-Fall
               val2 = val(Betragstring)
               if not empty(val2)
                  if lUmkehren
                     res += " <> "+ ltrim(str(val2, 10, 2)) 
                  else
                     res += " = "+ ltrim(str(val2, 10, 2)) 
                  endif
               endif
            endif
         endif


         // Testen auf '>'-Fall
         if asc(left(Betragstring, 1)) = 62
            if asc(subst(Betragstring, 2, 1) ) = 61
               val2 = val(subst(Betragstring, 3, 99))
//               if not empty(val2)
               	if lUmkehren
	                  res += " < " + ltrim(str(val2,10,2)) 
                  else
	                  res += " >= " + ltrim(str(val2,10,2))
						endif
//               endif
            else
               val2 = val(subst(Betragstring, 2, 99)) 
//               if not empty(val2)
               	if lUmkehren
	                  res += " <= " + ltrim(str(val2,10,2))
                  else
	                  res += " > " + ltrim(str(val2,10,2))
                  endif
//               endif
            endif
         endif

         // Testen auf '<'-Fall
         if asc(left(Betragstring,1)) = 60
            if asc(subst(Betragstring,2,1)) = 61
               val2 = val(subst(Betragstring,3,99))
//               if not empty(val2)
               	if lUmkehren
	                  res += " > " + ltrim(str(val2,10,2))
						else
   	               res += " <= " + ltrim(str(val2,10,2))
//                  endif
               endif
            else
               val2 = val(subst(Betragstring, 2, 99)) 
//               if not empty(val2)
               	if lUmkehren
	                  res += " >= " + ltrim(str(val2,10,2)) 
						else
   	               res += " < " + ltrim(str(val2,10,2)) 
                  endif
//               endif
            endif
         endif 
         res += ")"
      else
      	res = ""
      endif
      return(res)  

//---------------------------------------------------------------------------------
   Function Analyse_BoolFilter(BoolFeldname, Feld)
   	Boolstring = ltrim(Feld.value)
      if not empty(Boolstring)
         res = "(" + BoolFeldname
         if ("TRUE" $ Boolstring) or ("WAHR" $ Boolstring) or ("JA" $ Boolstring)
         	res += " = 1)"
         else
				if "NULL" $ Boolstring
					res += " is null)"
            else
	         	res += " = 0)"
            endif
         endif
      endif
      return(res)  

//---------------------------------------------------------------------------------
   function ReplaceApostrophe(cText)
		cRet = ltrim(trim(cText))
      local nCount
      for nCount = 1 to len(cRet)*2 step 2
         nPos = at( ['], cRet, nCount)
         if nPos == 0
            exit
         else
            cRet := stuff( cRet, nPos, 1, "''" )
         endif
      endfor // next
      return cRet


//---------------------------------------------------------------------------------
   Function Freeze(oForm)
   	if oForm.baseClassname = "form"
         if Type("LockWindowUpdate") # "FP"
             extern CLOGICAL LockWindowUpdate(CHANDLE) User32
         endif

         LockWindowUpdate(oForm.hWnd)  && Freeze
      else
      	? oForm.baseClassname + " ist kein Formular!"
      endif
   return
  
//---------------------------------------------------------------------------------
   Function UnFreeze
      If Type("LockWindowUpdate") # "FP"
         extern CLOGICAL LockWindowUpdate(CHANDLE) User32
      EndIf
      LockWindowUpdate(0)  && UnFreeze
   return

//---------------------------------------------------------------------------------
   Function Form_repaint(oForm)
      if type("UpdateWindow") # "FP"
         extern CLOGICAL UpdateWindow(CHANDLE) User32
      endif
      UpdateWindow(oForm.hWND)
		return
		
//---------------------------------------------------------------------------------
   Function TimeToIndustryHour(cTime)
      nPos1 = at(":", ctime,1)
      nPos2 = at(":", ctime,2)
      if nPos1 # 0 and nPos2 # 0
         nStd=val(left(cTime, nPos1-1)) 
         nMin=val(subst(cTime, nPos1+1, nPos2 - nPos1 -1))
         nSec=val(subst(cTime, nPos2+1, 9))
         nTime = nStd+nMin/60 + nSec/60/100
         roundedTime = ceiling(nTime * 20) / 20
         return( roundedTime )
      else
         return( 0 )
      endif


//---------------------------------------------------------------------------------
   function Zeig_Fehler(cCmd, cMld, nLineno)
   	set procedure to Fehlermeldung.wfm addi      
      fErr = new FehlerMldg()
      fErr.mdi = false
      fErr.Editor_Befehl.value = cCmd
		fErr.Anz_Befehlzeichen.text = ltrim(str(len(cCmd)))
      fErr.Editor_Meld.value = "Fehler beim Speichern!"+chr(13) + cMld + chr(13)+ "LineNo: "+ltrim(str(nLineno))
      fErr.readmodal()
      close procedure Fehlermeldung.wfm	
		return

//---------------------------------------------------------------------------------
   function GetLocalConnectionString( )
		cFile = "LocalConnectionString.txt"
		f = new File( )
		cRetVal = ""
		if f.exists( cFile )
			f.open( cFile ) 
			cRetVal = f.gets( ) 
			f.close( ) 
		else
			cRetVal = "0"
		endif
		return cRetVal
