********************************************************************************
********************************************************************************
********************************************************************************
*****
*****  Programm:         	ph_filterGrid1.cc
*****  Autor             	Peter Hegelbach
*****  Metric            	6 (Pixel)
*****  zuletzt gendert: 	17.08.2017
*****
********************************************************************************
********************************************************************************
/*
Fieldtypes:
	tex	text
   nuT	numeric Characters
   Be2	Amount with 2 decimal, alignement right
	Be4	Betragsfeld mit 4 decimal,  alignement right
   log	logical
	dat 	Datum
*/

class ph_FilterGrid(parentObj, cTableOrView, oDatabase) of CONTAINER(parentObj, cTableOrView, oDatabase) custom
	set procedure to Library.prg additive
	this.ListOrView 	= cTableOrView 
   this.database 		= oDatabase
   this.currentID		= -1
   this.StandardID	= -1
   with (this)
      metric         := 6  
      borderStyle    := 4 
      colornormal    := "Black/Lavender"
      width          := 80
      height         := 20
		visible 			:= false
   endwith

   this.GRID1 = new GRID(this)
   with (this.Grid1)
		cellHeight        := 18
      integralHeight    := true
      rowSelect         := true
      hasRowLines       := true
      hasIndicator      := true
      bgColor           := "Gray"
      colorNormal       := "Black/White"
      colorRowSelect    := "Black/Moccasin"
      colorHighLight    := "White/Crimson"
      colorRowLines     := "Silver"
      hasColumnHeadings := true
      headingColorNormal:= "Black/Silver"
      colorColumnHeader := "black/silver"
      colorRowHeader    := "black/silver"

      allowEditing      := false
      allowRowSizing    := false
      allowColumnMoving := false
      allowAddRows      := false
      hScrollBar        := 0  // Aus
      vScrollBar        := 1  // Ein
      borderStyle       := 2  // Relief negativ
      pageno            := 0

      fontSize          := 9.0
      headingFontSize   := 9.0
      top               := 41
      width             := 400
      left              := 0
   endwith

   this.sortIcon = new image(this)
   with (this.sortIcon)
   	height = 11
      left = 200
      top = this.Grid1.top + 4
      width =11
      borderStyle = 3
      datasource = "filename Sort_down.ico"
   endwith

   this.LabelFilter = new TEXTLABEL(this)
   with (this.LabelFilter)
      height = 14
      left = 2
      top = 0
      width = 70
      text = "Filterzeile:"
      fontSize = 8
      transparent = true
   endwith

	this.Filter_del  = new ph_Filter_del2(this)
   this.Filter_edit = new ph_Filter_edit2(this)

*-------------------------------------------------------------------------------
	function resize
      this.height = this.parent.height - this.top - 2
      this.Grid1.height = this.height - this.Grid1.top
      this.width = this.parent.width  - 6
      this.Grid1.width = this.width - this.Grid1.left - 4
      return
   	  
*-------------------------------------------------------------------------------
   function myinit(iUserFID, iClientFID)
		this.UserFID = iUserFID
		this.ClientFID = iClientFID
		oGrid = this.GRID1
		oForm = this
		do while oForm.baseClassName <> "FORM" and oForm.baseClassName <> "SUBFORM"
			oForm = oForm.parent
		enddo	
      oForm.freeze(oForm)	
		oGrid.height 	= oGrid.parent.height - oGrid.top - 1
		oGrid.width 	= oGrid.parent.width - oGrid.left - 1 
      oGrid.qGridSetup = new AdoQuery()
      oGrid.qGridSetup.database = oGrid.parent.database
      oGrid.qGridSetup.requestLive = false
      oGrid.qGridSetup.sql = "select * from GRIDSET S where S.GRIDS_LIST = '" + oGrid.parent.ListOrView +;
				"' and S.GRIDS_ClientFID = " + iClientFID + " and S.GRIDS_UserFID = " + iUserFID
		oGrid.qGridSetup.active = true
      if oGrid.qGridSetup.rowset.count() < 1
      	// noch kein Datensatz fr diesen User, darum Kopie anlegen vom SysUser 0 

         oGrid.qGridSetup.active = false
         oGrid.qGridSetup.sql = "select S.GRIDS_ID, S.GRIDS_SORTORDER from GRIDSET S where S.GRIDS_LIST = '" +;
					oGrid.parent.ListOrView + "'  and S.GRIDS_UserFID = 0"
         oGrid.qGridSetup.active = true
         oldID = ltrim(str(oGrid.qGridSetup.rowset.fields["GRIDS_ID"].value))
         oGrid.SortOrder = oGrid.qGridSetup.rowset.fields["GRIDS_SORTORDER"].value
         oGrid.qGridSetup.active = false
         oGrid.parent.StandardID = oldID

			n0  = "insert into GRIDSET (GRIDS_LIST, GRIDS_ClientFID, GRIDS_UserFID, GRIDS_SORTORDER) "
         n0 += "values ('" + oGrid.parent.ListOrView + "', " + oGrid.parent.ClientFID + ", " + oGrid.parent.UserFID + ", '" +oGrid.SortOrder + "')"
         try
            oGrid.parent.database.executeSQL(n0)
         catch (exception e)
               MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
         endtry
         n0  = "select max(GRIDS_ID) as maxID from GRIDSET S where S.GRIDS_LIST = '" + oGrid.parent.ListOrView 
         n0 += "' and S.GRIDS_ClientFID = " + oGrid.parent.ClientFID + " and S.GRIDS_UserFID = " + oGrid.parent.UserFID
         oGrid.qGridSetup.sql = n0
         oGrid.qGridSetup.active = true
         oGrid.parent.currentID = ltrim(str(oGrid.qGridSetup.rowset.fields["maxID"].value))
         oGrid.qGridSetup.active = false
         oGrid.qGridSetup.sql = "select * from GRIDSETUP where GRIDU_GRIDSETFID = " + oGrid.parent.StandardID
         oGrid.qGridSetup.active = true

         oGrid.qGridSetup.rowset.first()
         do while not oGrid.qGridSetup.rowset.endOfSet
         	n0  = "insert into GRIDSETUP (GRIDU_GRIDSETFID, GRIDU_COLUMNNO, GRIDU_FIELDDB, GRIDU_DISPLAYNAME, GRIDU_WIDTH, GRIDU_VISIBLE, GRIDU_ALIGNEMENT, GRIDU_KEYFIELD) values ("
            n0 += oGrid.parent.currentID + ", " 
            n0 += oGrid.qGridSetup.rowset.fields["GRIDU_COLUMNNO"].value + ", "
				n0 += "'" + oGrid.qGridSetup.rowset.fields["GRIDU_FIELDDB"].value + "', '" + oGrid.qGridSetup.rowset.fields["GRIDU_DISPLAYNAME"].value + "', "
            n0 += iif( empty(oGrid.qGridSetup.rowset.fields["GRIDU_WIDTH"].value), "0", oGrid.qGridSetup.rowset.fields["GRIDU_WIDTH"].value)  + ", "
            n0 += iif( oGrid.qGridSetup.rowset.fields["GRIDU_VISIBLE"].value = true, "1", "0") + ", "
				n0 += "'" + oGrid.qGridSetup.rowset.fields["GRIDU_ALIGNEMENT"].value + "', " 
				n0 += iif(oGrid.qGridSetup.rowset.fields["GRIDU_KEYFIELD"].value = true, "1", "0")  + ")"
				
				try
            	oGrid.parent.database.executeSQL(n0)
            catch (exception e)
               MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
	         endtry
   			oGrid.qGridSetup.rowset.next()
         enddo
      else

         // Standard-Grid wegen Funktion Zurcksetzen eruieren
         oGrid.qGridSetup.active = false
			n0 =  " select GRIDS_ID from GRIDSET S where S.GRIDS_LIST = '" + oGrid.parent.ListOrView +;
					"' and S.GRIDS_ClientFID =0 and S.GRIDS_UserFID = 0"				// Standard mit 0 bei ClientFID und UserFID
         oGrid.qGridSetup.sql = n0
         oGrid.qGridSetup.active = true
         oldID = ltrim(str(oGrid.qGridSetup.rowset.fields["GRIDS_ID"].value))	
         oGrid.qGridSetup.active = false
         oGrid.parent.StandardID = oldID

      	// kein neuer User oder Client, darum gespeicherte Daten lesen aus dem bergeordneten GridSet
         oGrid.qGridSetup.active = false
         n0  = " select GRIDS_ID, GRIDS_SORTORDER from GRIDSET S where S.GRIDS_LIST = '" + oGrid.parent.ListOrView 
         n0 += "' and S.GRIDS_ClientFID = " + oGrid.parent.ClientFID + " and S.GRIDS_UserFID = "+ oGrid.parent.UserFID		
         oGrid.qGridSetup.sql = n0
         oGrid.qGridSetup.active = true
         oGrid.SortOrder = oGrid.qGridSetup.rowset.fields["GRIDS_SORTORDER"].value
         oGrid.parent.currentID = ltrim(str( oGrid.qGridSetup.rowset.fields["GRIDS_ID"].value ))
         oGrid.qGridSetup.active = false
      endif

      // hier weiterfahren fr beide Flle (neues GridSet oder bereits vorhanden

      // Rowset bilden mit Felderliste 
      oGrid.qGridSetup.active = false
      n0  = "select GRIDU_COLUMNNO, GRIDU_FIELDDB, GRIDU_DISPLAYNAME, GRIDU_WIDTH, GRIDU_VISIBLE, GRIDU_ALIGNEMENT, GRIDU_KEYFIELD "
      n0 += "from GRIDSETUP S " 
      n0 += "where GRIDU_GRIDSETFID = " + oGrid.parent.currentID + " order by GRIDU_COLUMNNO"	
		oGrid.qGridSetup.sql = n0
      oGrid.qGridSetup.active = true

      // Felder in ein Array bertragen
      maxCol = oGrid.qGridSetup.rowset.count()
      oGrid.qGridSetup.rowset.first()
      oGrid.Feld = new Array(maxCol, 7)
      cSQL = "select "
      for i = 1 to maxCol
      	oGrid.Feld[i, 1] = trim( oGrid.qGridSetup.rowset.fields["GRIDU_FIELDDB"].value )
         oGrid.Feld[i, 2] = oGrid.qGridSetup.rowset.fields["GRIDU_DISPLAYNAME"].value 
         oGrid.Feld[i, 3] = oGrid.qGridSetup.rowset.fields["GRIDU_ALIGNEMENT"].value 
         oGrid.Feld[i, 4] = max( 5, oGrid.qGridSetup.rowset.fields["GRIDU_WIDTH"].value )
         oGrid.Feld[i, 5] = oGrid.qGridSetup.rowset.fields["GRIDU_KEYFIELD"].value 
         oGrid.Feld[i, 6] = oGrid.qGridSetup.rowset.fields["GRIDU_VISIBLE"].value 
			// oGrid.Feld[i,7] needed for Objectreference to FilterFeld
 			cSQL += oGrid.Feld[i,1]
         if i <> maxCol
            cSQL += ", "     	// beim letzten Schleifendurchlauf kein Komma mehr anhngen, da kein weiters Feld
         endif
         oGrid.qGridSetup.rowset.next()
      endfor
      cSQL += " from " + oGrid.parent.ListOrView
		oGrid.cFilterstring = ""
      oGrid.cSQLString = cSQL
		
      // Sortierung einstellen   und
      // nicht sichtbare Felder zhlen	
      oGrid.SortCol = 0
      SortOrder_oD = class::Sort_richtungsfrei( oGrid.sortOrder )
      ii = 0
		for i = 1 to maxCol
         if oGrid.Feld[i,6]= true		// Feld sichtbar?
            ii += 1
            if SortOrder_oD = oGrid.Feld[i, 1]
               oGrid.sortCol = ii 
            endif
         endif   	
      endfor
		sichtbareFelder =	ii	

      oGrid.q = new AdoQuery()
      oGrid.q.database = oGrid.parent.database
      oGrid.q.requestLive = false
      oGrid.q.sql = class::Build_SQLString(oGrid)	
						//cSQL + iif(oGrid.SortCol <> 0, " order by " + oGrid.SortOrder, "")
      oGrid.q.active = true
		
      nBreite = oGrid.width - 48     // 44 fr Indicator und Scrollbar
      oGrid.datalink = oGrid.q.rowset
      oGrid.columns = new Array(sichtbareFelder)
      ii = 1          // Zhler fr tatschlich sichtbare Felder
      for i = 1 to maxCol
      	if oGrid.Feld[i, 6] = true		// sichtbar
            ColName = "Col"+ltrim(rtrim(str(ii)))
            oGrid.columns[ColName] = new gridcolumn(oGrid)

            do case
            case oGrid.Feld[i, 3] = "tex"
               oGrid.columns[ColName].editorType = 1   // Eingabefeld
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent) 
               oGrid.Feld[i, 7].Modus = "Text"
				case oGrid.Feld[i, 3] = "log"
               oGrid.columns[ColName].editorType = 2   // Markierfeld
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent) 
               oGrid.Feld[i, 7].Modus = "Bool"
            case oGrid.Feld[i, 3] = "be2"
               oGrid.columns[ColName].editorType = 1   // Eingabefeld
               oGrid.columns[ColName].editorControl.picture = "@J 9,999.99"
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent)
               oGrid.Feld[i, 7].Modus = "Betrag" 
            case oGrid.Feld[i, 3] = "be4"
               oGrid.columns[ColName].editorType = 1   // Eingabefeld
               oGrid.columns[ColName].editorControl.picture = "@J 9,999.9999"
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent)
               oGrid.Feld[i, 7].Modus = "Betrag" 					
            case oGrid.Feld[i, 3] = "nuT"
               oGrid.columns[ColName].editorType = 1   // Eingabefeld
               oGrid.columns[ColName].editorControl.function = "@B"
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent) 
               oGrid.Feld[i, 7].Modus = "numText"
				case oGrid.Feld[i, 3] = "dat"
               oGrid.columns[ColName].editorType = 1   // Eingabefeld
//					oGrid.columns[ColName].editorControl.function = "@E 99.99.99"
               oGrid.Feld[i, 7] = new ph_Filterfeld2(oGrid.parent) 
               oGrid.Feld[i, 7].Modus = "Datum"	
            endcase
				oGrid.columns[ColName].FeldNr = i         // wird fr Abspeicherung Feldbreite bentigt
	         oGrid.Feld[i,7].sichtbFeldNr = ii		   // wird fr re-sizing des Filterfelds bentigt

            oGrid.columns[ColName].datalink = oGrid.datalink.fields[i]
            oGrid.columns[ColName].width = oGrid.Feld[i,4]  * 8 		//* nBreite
            oGrid.columns[ColName].headingControl.value = oGrid.Feld[i,2]
            oGrid.columns[ColName].headingControl.onLeftMouseUp = class::HC_onLeftMouseUp
            oGrid.columns[ColName].headingControl.ColNo = ii
            ii += 1
         else
         	oGrid.Feld[i, 7] = null		// kein sichtbares Feld, darum auch kein Filterfeld
         endif
         
      endfor
      
		oGrid.activeQuery = "Q1"							// Voreinstellung
		oGrid.Q1 = new Object()		// Pseudo-Objekt, damit es spter beim erstmaligen ndern gelscht werden kann
      class::SortIcon_positionieren(oGrid)
		oGrid.parent.visible = true
      class::FilterFelder_positionieren(oGrid)
		oGrid.datalink.first()
      oForm.unfreeze(oForm)
   	return
	
*-------------------------------------------------------------------------------
   function Feldauswahl
      f= new FeldForm()
		f.mdi = false
      f.MyArray = this.Grid1.Feld
      f.parentGrid = this
      rVal = f.readModal()
      return rVal

*-------------------------------------------------------------------------------
   function HC_onLeftMouseUp(flags, col, row)  // fr Aenderung der Sortierung wie auch fr Aenderung Spaltenbreite
   	if this.parent.columns[this.ColNo].width - col < 0.1    // whrend Sizing ist Spaltenbreite immer gleich col, da spez. Mousepointer exakt darber
         if this.ColNo <= this.parent.SortCol 	//Sort-Icon muss neu positioniert werden, wenn Spaltenbreite verndert wird und Sort auf einer spteren Spalte
         	class::SortIcon_positionieren(this.parent, this.parent.SortCol)
         endif         	
         class::FilterFelder_positionieren(this.parent)
         this.parent.Feld[this.ColNo,4] = col / 8
			n0  = "update GRIDSETUP set GRIDU_WIDTH = " + ltrim(str(round(this.parent.Feld[this.ColNo, 4], 0))) 
         n0 += " where GRIDU_GRIDSETFID = " + this.parent.parent.currentID + " and GRIDU_COLUMNNO = " + ltrim(str(this.parent.columns[this.ColNo].FeldNr))		
         try
            this.parent.parent.database.executeSQL(n0)
         catch (exception e)
            MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
         endtry
      else
      	if this.ColNo = this.parent.SortCol    // schon nach dieser Spalte sortiert
         	Pos = this.parent.SortOrder.indexOf(" DESC") 
            if Pos > - 1
            	this.parent.sortOrder = class::Sort_richtungsfrei( this.parent.sortOrder )
            else
            	this.parent.sortOrder += " DESC"   	//Desc ergnzen
            endif	
         else               // neu auf diese Spalte
            this.parent.SortCol = this.ColNo
            this.parent.SortOrder = this.parent.columns[this.ColNo].datalink.fieldName	// immer aufsteigend, wenn neu als Spalte gewhlt
         endif
         // neue Sortreihenfolge in GridSet speichern
         n0  = "update GRIDSET set GRIDS_SORTORDER = '"  + this.parent.SortOrder
         n0 += "' where GRIDS_ID = "  + this.parent.parent.currentID
			try
         	this.parent.parent.database.executeSQL(n0)
         catch (exception e)
            MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
         endtry

         // SQL-String mit neuer Sortreiehenfolge neu aufbauen
         newSQL = class::Build_SQLString(this.parent)
			class::Grid_newLink(this.parent, newSQL)		// Parameter1 ist Grid1 (Grid-Objekt)
         class::SortIcon_positionieren(this.parent, this.ColNo)
		endif	
      return

*-------------------------------------------------------------------------------
   function Sort_richtungsfrei(cSortOrder)
   // entfernt eine allfllige DESC-Klausel in der order by Angabe
   	Pos = cSortOrder.indexOf(" DESC") 
      return ( iif( Pos > -1, cSortOrder.stuff(Pos, 5), cSortOrder ))	

*-------------------------------------------------------------------------------
   function Build_SQLString(oGrid1)
		cListorView = oGrid1.parent.ListOrView
		if cListOrView = "MANDANT" or cListOrView = "LAND" or cListOrView = "PLZCODE" 
			Filter = ""
		else	
			Filter = "Mandant_FID = " + oGrid1.parent.ClientFID 
		endif
		if not empty(oGrid1.parent.parent.AdditionalFilter)
			Filter += iif(not empty(Filter), " and ", " ") + oGrid1.parent.parent.AdditionalFilter 
		endif
		if not empty(oGrid1.cFilterstring)
			filter += iif(not empty(Filter), " and ", " ") + oGrid1.cFilterstring
		endif	

		newSQL  = oGrid1.cSQLString + iif(not empty(Filter), " where " + Filter, "")
      newSQL += " order by " + oGrid1.SortOrder
		this.SQL = newSQL
   	return(newSQL)

*-------------------------------------------------------------------------------
	function Grid_newLink(oGrid1, SQL_Command)
		form.freeze(form)
		
		// save datalinks for all fields 
		maxfields = oGrid1.columns.size
		aFields = new array(maxfields, 3)
		for i = 1 to maxfields
			aFields[i, 1] = oGrid1.columns[i].datalink.fieldname
			aFields[i, 2] = oGrid1.columns[i].headingControl.value
			aFields[i, 3] = oGrid1.columns[i].width
		endfor
		
		if oGrid1.activeQuery = "Q1"
			oGrid1.Q2 = new adoQuery()
			oGrid1.activeQuery = "Q2"
			newQuery = oGrid1.Q2
			release object oGrid1.Q1
		else
			oGrid1.Q1 = new adoQuery()
			oGrid1.activeQuery = "Q1"
			newQuery = oGrid1.Q1
			release object oGrid1.Q2			
		endif
		
		with(newQuery)
			database = form.hitTime_ADO
			sql = SQL_Command
			requestLive = false
			active = true
		endwith
		oGrid1.Q = newQuery
		oGrid1.datalink = oGrid1.Q.rowset
			
		for i = 1 to maxfields	
			oGrid1.columns[i].datalink = oGrid1.Q.rowset.fields[ aFields[i, 1] ]
			oGrid1.columns[i].headingControl.value = aFields[i, 2]
			oGrid1.columns[i].width = aFields[i, 3]
		endfor		

		oGrid1.refresh()	
		form.unfreeze()
		return
*-------------------------------------------------------------------------------
   function SortIcon_positionieren(oGrid)
      IsDescending = not oGrid.SortOrder.indexOf(" DESC") < 0
		oGrid.parent.sortIcon.dataSource = iif(isDescending, "filename Sort_down.ico", "filename Sort_up.ico")
      pos_left = 24   		//  Versatz fr Indicator-Spalte
		for i = 1 to oGrid.SortCol
         pos_left += oGrid.columns[i].width
      endfor
      pos_left -= 18
      oGrid.parent.sortIcon.left = pos_left
      return

*-------------------------------------------------------------------------------
   function FilterFelder_positionieren(oGrid)
   	pos_left = 22 		//  Versatz fr Indicator-Spalte	
      ii = 0
      maxCol = alen(oGrid.Feld, 1)
      for i = 1 to maxCol
			if oGrid.Feld[i, 6] = true		// sichtbar ?
         	ii += 1
            oGrid.Feld[i,7].left  = pos_left 
            oGrid.Feld[i,7].width = oGrid.columns[ii].width - 1
            pos_left += oGrid.columns[ii].width + 1
			endif
      endfor
		return

endclass
*/

*===============================================================================
 CLASS ph_Filterfeld2( oCont ) of ENTRYFIELD( oCont ) custom
*-------------------------------------------------------------------------------
   with (this)
   	onGotFocus		:= class::Filterfeld_onGotFocus
		onLostFocus		:= class::Filterfeld_onLostFocus
      onChange			:= class::Filterfeld_onChange
      height 			:= 20
      left 				:= 22
      top 				:= 18
      width 			:= 50
      fontSize 		:= 9
      value 			:= ""
      colorNormal		:= "Crimson/white"
      colorHighlight	:= "Crimson/0x99ffff"
      validErrorMsg 	:= "Ungltige Eingabe "
      pageno 			:= 0
		borderStyle 	:= 4
      font 				:=	"Arial"
      function 		:= "!"
		fontBold 		:= false
      fontSize 		:= 9
   endwith

*-------------------------------------------------------------------------------
   function Filterfeld_onGotFocus
		if type("this.Modus") <> "U"
         with (this.parent.Filter_edit)
            Modus = this.Modus
            left = this.left + this.width - 17
            visible = true
            Rueckgabefeld = this
         endwith
      endif
   	return

*-------------------------------------------------------------------------------
   function Filterfeld_onLostFocus
		with (this.parent.Filter_edit)
      	visible = false
         Rueckgabefeld = null
      endwith
   	return

*-------------------------------------------------------------------------------
   function Filterfeld_onChange
		oFeld = this.parent.Grid1.Feld
      cFilter =  ""   
      maxCol = alen(oFeld, 1)
      ii = 0
      for i = 1 to maxCol            
			if not empty(oFeld[i, 7])      // von nicht sichbaren Felder wird gar kein Filterfeld angelegt
         	ii += 1
            if not empty(oFeld[i, 7].value)
            	do Case
               case oFeld[i,3] = "tex" 
                  cFilter += iif(not empty(cFilter), " and ","")
                  cFilter += Analyse_Textfilter(oFeld[i,1], oFeld[i,7])
               case oFeld[i,3] = "be2"
                  cFilter += iif(not empty(cFilter), " and ","")
                  cFilter += Analyse_Betragfilter(oFeld[i,1], oFeld[i,7])
               case oFeld[i,3] = "dat"
                  cFilter += iif(not empty(cFilter), " and ","")
                  cFilter += Analyse_Datumfilter(oFeld[i,1], oFeld[i,7])
               case oFeld[i,3] = "nuT"
                  cFilter += iif(not empty(cFilter), " and ","")
                  cFilter += Analyse_numTextFilter(oFeld[i,1], oFeld[i,7])
               case oFeld[i,3] = "log"
                  cFilter += iif(not empty(cFilter), " and ","")
                  cFilter += Analyse_BoolFilter(oFeld[i,1], oFeld[i,7])
               endcase
            endif
			endif
      endfor	
      this.parent.Grid1.cFilterstring = cFilter
      newSQL = ph_FilterGrid::Build_SQLString(this.parent.Grid1)
		oGrid = this.parent.Grid1
		oGrid.parent.Grid_newLink(oGrid, newSQL)		// Parameter1 ist Grid1 (Grid-Objekt)
      return   			


 ENDCLASS

*===============================================================================
 CLASS ph_Filter_del2( oCont ) of Pushbutton( oCont ) custom
*-------------------------------------------------------------------------------
 	with (this)
	   onClick		:= Filter_del_onClick
      height 		:= 22
      left			:= 0
      top 			:= 17
      width 		:= 21.0
      text 			:= "del"
      colorNormal	:= "Black/White"
		borderStyle := 0
		systemTheme := true
   endwith

   
*-------------------------------------------------------------------------------
 function Filter_del_onClick
	oGrid = this.parent.Grid1
   for i = 1 to alen( oGrid.Feld, 1 )
   	if not empty(oGrid.Feld[i,7])
			oGrid.Feld[i,7].value = ""
      endif
   endfor
   this.parent.Grid1.cFilterstring = ""
   newSQL = ph_FilterGrid::Build_SQLString(this.parent.Grid1)
	oGrid = this.parent.Grid1
	oGrid.parent.Grid_newLink(oGrid, newSQL)		// Parameter1 ist Grid1 (Grid-Objekt)
   return
   

 endclass

*===============================================================================
 CLASS ph_Filter_edit2( oCont ) of Pushbutton( oCont ) custom
*-------------------------------------------------------------------------------
 	with (this)
      height 		:= 18
      left 			:= 0
      top 			:= 0
      width 		:= 18
      text 			:= ".."
      systemTheme := true
      colorNormal := "BtnText/silver"
      speedbar		:= true
      borderStyle := 0
      visible 		:= false
      onClick		:= class::Filter_edit_onClick
   endwith
   this.Modus		= "none"
   this.Rueckgabefeld = "none"

*-------------------------------------------------------------------------------
   function Filter_edit_onClick
   local f
   do case
      Case this.Modus = "Text"
         set procedure to Filterfeld_Text.wfm addi
         f = new Filterfeld_Text()
         f.mdi = false // Nicht-MDI festlegen
         f.Rueckgabefeld = this.Rueckgabefeld
         f.ReadModal()
			close procedure Filterfeld_Text.wfm 
      Case this.Modus = "Datum"
         set procedure to Filterfeld_Datum.wfm addi
         f = new Filterfeld_Datum()
         f.mdi = false // Nicht-MDI festlegen
         f.Rueckgabefeld = this.Rueckgabefeld
         f.ReadModal()
			close procedure Filterfeld_Datum.wfm 
      Case this.Modus = "numText"
         set procedure to Filterfeld_numText.wfm addi
         f = new Filterfeld_numText()
         f.mdi = false // Nicht-MDI festlegen
         f.Rueckgabefeld = this.Rueckgabefeld
         f.ReadModal()
			close procedure Filterfeld_numText.wfm 
      Case this.Modus = "Betrag"
         set procedure to Filterfeld_Betrag.wfm addi
         f = new Filterfeld_Betrag()
         f.mdi = false // Nicht-MDI festlegen
         f.Rueckgabefeld = this.Rueckgabefeld
         f.ReadModal()
			close procedure Filterfeld_Betrag.wfm 
      Case this.Modus = "Bool"
         set procedure to Filterfeld_Bool.wfm addi
         f = new Filterfeld_Bool()
         f.mdi = false // Nicht-MDI festlegen
         f.Rueckgabefeld = this.Rueckgabefeld
         f.ReadModal()  
			close procedure Filterfeld_Bool.wfm 
      Endcase
      this.Rueckgabefeld.Filterfeld_onChange()
      return

 endclass

********************************************************************************
********************************************************************************
*****                                                                      *****
*****  Programm:         Feldauswahl.wfm                                   *****
*****  Autor             Peter Hegelbach                                   *****
*****  zuletzt gendert: 11.08.2014                                        *****
*****                                                                      *****
********************************************************************************
********************************************************************************



clear
return

** END HEADER -- Diese Zeile nicht entfernen
//
// Erstellt am 23.08.14
//
parameter bModal
local f
f = new FeldForm()
if (bModal)
   f.mdi = false // Nicht-MDI festlegen
   f.ReadModal()
else
   f.Open()
endif

class FeldForm of FORM
   with (this)
		set procedure to hit_Control.cc additive
		onOpen = class::INIT
      metric = 6	// Pixel
      visible = false
      colorNormal = "lavender"
      height = 460
      left = 84.0
      top = 145.0
      width = 440
      text = "hit"
      clientEdge = false
      autoCenter = true
      mdi = false
      smallTitle = true
      sizeable = false
      moveable = false
      escExit = false
      maximize = false
      minimize = false
   endwith

   this.Titel = new BIGTITEL(this)
   with (this.Titel)
      left = 5.0
      top = 5.0
      width = 430
      text = "Feldauswahl"
   endwith

   this.BUTTON_OK = new PH_BUTTON_OK(this)
   with (this.BUTTON_OK)
      onClick = class::BUTTON_OKCLICK
      height = 28
		left = 300
      top =  214
      width = 130
      default = false
   endwith

   this.BUTTON_ZURUECKSETZEN = new PH_BUTTON_OK(this)
   with (this.BUTTON_ZURUECKSETZEN)
   	onClick = class::Button_zurueck_onClick
      height = 28
      left = 300
      top = 249
      width = 130
      text = "&zurcksetzen"
      default = true
      upBitmap = "RESOURCE #148"
      disabledBitmap = "RESOURCE #149"
      fontBold = false
   endwith

   this.BUTTON_CANCEL = new PH_BUTTON_ABBRUCH(this)
   with (this.BUTTON_CANCEL)
      onClick = class::BUTTON_CANCEL_ONCLICK
      height = 28
		left = 300
      top = 284
      width = 130
      text = "&Abbruch"
   endwith

   this.FELDWAHL = new CONTAINER(this)
   with (this.FELDWAHL)
   	onOpen = class::Feldwahl_onOpen
      left = 7.0
      top = 44.0
      width = 283.0
      height = 400.0
      colorNormal = "gray"
      borderStyle = 4	// Einfach
   endwith
   
   this.FELDWAHL.SPALTE1 = new PH_COLHEADER(this.FELDWAHL)
   with (this.FELDWAHL.SPALTE1)
   	left = 0.0
      top = 0.0
      width = 28
      text = " #"
   endwith

   this.FELDWAHL.SPALTE2 = new PH_COLHEADER(this.FELDWAHL)
   with (this.FELDWAHL.SPALTE2)
      left = 29.0
      top = 0.0
      width = 149
      text = " Spaltenname"
   endwith

   this.FELDWAHL.SPALTE3 = new PH_COLHEADER(this.FELDWAHL)
   with (this.FELDWAHL.SPALTE3)
      left = 179
      top = 0.0
      width = 76
      text = " anzeigen"
   endwith

   this.Pfeil_top = new PH_ArrowButton(this)
   with (this.Pfeil_top)
      top = 62
      upBitmap = "filename Arrow_top.ico"
      onClick = class::Pfeil_top_onClick
   endwith

   this.Pfeil_up = new PH_ArrowButton(this)
   with (this.Pfeil_up)
      top = 98
      upBitmap = "filename Arrow_up.ico"
      onClick = class::Pfeil_up_onClick
   endwith

   this.Pfeil_down = new PH_ArrowButton(this)
   with (this.Pfeil_down)
      top = 134
      upBitmap = "filename Arrow_down.ico"
      onClick = class::Pfeil_down_onClick
   endwith

   this.Pfeil_bottom = new PH_ArrowButton(this)
   with (this.Pfeil_bottom)
      top = 170
      upBitmap = "filename Arrow_bottom.ico"
      onClick = class::Pfeil_bottom_onClick
   endwith


*-------------------------------------------------------------------------------
   function Feldwahl_onOpen
   	this.selectedRow 				= 0
      this.ColorSelectedRow 		= "Black/Moccasin"
      this.ColorNonSelectedRow 	= "Black/White"
      class::Feldwahl_rowSelect(this.parent, 1)
      return

*-------------------------------------------------------------------------------
   function Feldwahl_rowSelect(oForm, LineNr)
   	if oForm.Feldwahl.selectedRow <> LineNr
      	oForm.Feldwahl.a[LineNr, 2].colornormal = oForm.Feldwahl.ColorSelectedRow
         oForm.Feldwahl.a[LineNr, 3].colornormal = oForm.Feldwahl.ColorSelectedRow

         oldRow = oForm.Feldwahl.selectedRow
			if oldRow <> 0           // beim ersten Druchlauf ist noch keien Zeile markiert
            oForm.Feldwahl.a[oldRow, 2].colornormal = oForm.Feldwahl.ColorNonSelectedRow
            oForm.Feldwahl.a[oldRow, 3].colornormal = oForm.Feldwahl.ColorNonSelectedRow
         endif
         oForm.Feldwahl.selectedRow = LineNr
      endif
   	return

*-------------------------------------------------------------------------------
   function Button_Cancel_onClick
      form.close(false)
      return

*-------------------------------------------------------------------------------
   function Button_Zurueck_onClick
		// altes Array kopieren, damit die derzeitige Reihenfolge eruiert werden kann
		maxFields = alen(this.parent.Feldwahl.a, 1)
      TempArray = new Array(maxFields, 2)
      for i = 1 to maxFields
      	TempArray[i,1] = this.parent.Feldwahl.a[i,1].Feldname		// Feldname
         TempArray[i,2] = i											// oldRowNo
      endfor

		qGridSetup = new AdoQuery()
      with (qGridSetup)
      	database = form.parentGrid.database
         requestLive = false
      	n0  = "select GRIDU_FIELDDB, GRIDU_DISPLAYNAME, GRIDU_COLUMNNO, GRIDU_VISIBLE "
         n0 += "from GRIDSETUP S  " 
         n0 += "where GRIDU_GRIDSETFID = " + form.parentGrid.standardID + " order by S.GRIDU_COLUMNNO"
         sql = n0
			active = true
         rowset.first()
      endwith

      i = 0
      do while not qGridSetup.rowset.endOfSet
      	i += 1
         z = class::findOldRowNo( qGridSetup.rowset.fields["GRIDU_FIELDDB"].value, TempArray )
		   this.parent.Feldwahl.a[i, 2].text = " " + qGridSetup.rowset.fields["GRIDU_Displayname"].value
			this.parent.Feldwahl.a[i, 2].rowNr = z
         this.parent.Feldwahl.a[i, 3].cb.value = qGridSetup.rowset.fields["GRIDU_VISIBLE"].value
			this.parent.Feldwahl.a[i, 3].rowNr = z
         this.parent.Feldwahl.a[i, 1].oldRowNo = z 
			qGridSetup.rowset.next()	
      enddo

      release TempArray
      qGridSetup.active = false
      release object qGridSetup
      
      form.Feldwahl.selectedRow	= 0
      class::Feldwahl_rowSelect(form, 1)
      form.Feldwahl.visible = true
      return

*-------------------------------------------------------------------------------
   function findOldRowNo(SearchString, phArray)
   	local i, maxRow
      i = 0
      maxRow = alen(phArray, 1)
		for i = 1 to maxRow
      	if SearchString = phArray[i, 1]
         	exit
         endif
      endfor
      if i = 0
      	i = 1
      endif
   	return(i)

*-------------------------------------------------------------------------------
   function init			// von form
		this.text = "Einstellungen " + this.parentGrid.ListOrView
      if type( "this.myArray" ) = null
         msgbox("Sorry, Zuweisung eines Arrays fehlt.","Error")
         form.close()
      else
      	this.Feldwahl.cellHeight = 19
         maxFields = alen( this.myArray, 1 )
         this.Feldwahl.a = new array(maxFields, 3)
         for i = 1 to maxFields
            this.Feldwahl.a[i, 1] = new PH_rowHeader(this.Feldwahl)
            this.Feldwahl.a[i, 1].top = i * ( this.Feldwahl.cellHeight + 1 )
            this.Feldwahl.a[i, 1].height = this.Feldwahl.cellHeight
            this.Feldwahl.a[i, 1].text = " " + ltrim(str(i))
            this.Feldwahl.a[i, 1].rowNr = i
            this.Feldwahl.a[i, 1].oldRowNo = i							// bentigt zum Zurckschreiben nach Aenderung der Reihenfolge
            this.Feldwahl.a[i, 1].Feldname = this.myArray[i, 1]	// bentigt fr alte Reihenfolge der Felder
            this.Feldwahl.a[i, 2] = new PH_Feldname(this.Feldwahl)
            this.Feldwahl.a[i, 2].top = i * ( this.Feldwahl.cellHeight + 1 )
            this.Feldwahl.a[i, 2].height = this.Feldwahl.cellHeight
            this.Feldwahl.a[i, 2].text = " " + this.myArray[i, 2]
            this.Feldwahl.a[i, 2].rowNr = i
            this.Feldwahl.a[i, 3] = new PH_VisibleCheckBox(this.Feldwahl)
            this.Feldwahl.a[i, 3].cb.value = this.myArray[i, 6]
            this.Feldwahl.a[i, 3].top = i * ( this.Feldwahl.cellHeight + 1 )
            this.Feldwahl.a[i, 3].height = this.Feldwahl.cellHeight
            this.Feldwahl.a[i, 3].rowNr = i
         endfor
         this.Feldwahl.height = max( ((i+1) * this.Feldwahl.cellHeight) + 1, 270)
         this.height = this.Feldwahl.height + this.Feldwahl.top + 5
         this.visible = true                                             
      endif
      return 

*-------------------------------------------------------------------------------
   function Button_OkClick
      maxFields = alen( this.parent.Feldwahl.a, 1 )
	  
      for i = 1 to maxFields
      	n0  = "update GRIDSETUP set GRIDU_COLUMNNEW = "
         n0 += this.parent.Feldwahl.a[i, 1].text + ", GRIDU_VISIBLE = "
         n0 += iif(this.parent.Feldwahl.a[i, 3].cb.value, "1", "0")
         n0 += " where GRIDU_GRIDSETFID = " + this.parent.parentGrid.currentID
         n0 += " and GRIDU_COLUMNNO = " + this.parent.Feldwahl.a[i, 1].oldRowNo
			try
            form.parentGrid.database.executeSQL(n0)
         catch (exception e)
               MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
         endtry
      endfor

      n0 = "update GRIDSETUP set GRIDU_COLUMNNO = GRIDU_COLUMNNEW where GRIDU_GRIDSETFID = " + this.parent.parentGrid.currentID
      try
         form.parentGrid.database.executeSQL(n0)
      catch (exception e)
            MsgBox("Fehler beim Speichern!"+chr(13) + e.message+chr(13) + "LineNo: "+e.lineNo)
      endtry   	
      form.close(true)
      return

*-------------------------------------------------------------------------------
   function Pfeil_top_onClick
   	selRow = form.Feldwahl.selectedRow
      if selRow > 1
         Local b2, b3, b4
      	b2 = form.Feldwahl.a[selRow, 2].text
         b3 = form.Feldwahl.a[selRow, 3].cb.value
         b4 = form.Feldwahl.a[selRow, 1].oldRowNo
         for i = selRow to 2 step - 1
            form.Feldwahl.a[i, 2].text = form.Feldwahl.a[i - 1, 2].text 
            form.Feldwahl.a[i, 3].cb.value = form.Feldwahl.a[i - 1, 3].cb.value
            form.Feldwahl.a[i, 1].oldRowNo = form.Feldwahl.a[i - 1, 1].oldRowNo 
         next i
         form.Feldwahl.a[1, 2].text = b2 
         form.Feldwahl.a[1, 3].cb.value = b3
         form.Feldwahl.a[1, 1].oldRowNo = b4
			class::Feldwahl_rowSelect(this.parent, 1)	
      endif
      return

*-------------------------------------------------------------------------------
   function Pfeil_bottom_onClick
   	selRow = form.Feldwahl.selectedRow
      maxRow = alen(form.myArray, 1)
   	if selRow < maxRow		// schon zuunterst, darum nichts tun
         Local b2, b3, b4
      	b2 = form.Feldwahl.a[selRow, 2].text
         b3 = form.Feldwahl.a[selRow, 3].cb.value
         b4 = form.Feldwahl.a[selRow, 1].oldRowNo
         for i = selRow to maxRow - 1
            form.Feldwahl.a[i, 2].text = form.Feldwahl.a[i + 1, 2].text 
            form.Feldwahl.a[i, 3].cb.value = form.Feldwahl.a[i + 1, 3].cb.value
            form.Feldwahl.a[i, 1].oldRowNo = form.Feldwahl.a[i + 1, 1].oldRowNo
         next i
         form.Feldwahl.a[maxRow, 2].text = b2 
         form.Feldwahl.a[maxRow, 3].cb.value = b3
         form.Feldwahl.a[maxRow, 1].oldRowNo = b4
			class::Feldwahl_rowSelect(this.parent, maxRow)	
      endif
      return

*-------------------------------------------------------------------------------
   function Pfeil_up_onClick
   	selRow = form.Feldwahl.selectedRow
   	if selRow > 1		// schon zuoberst, darum nichts tun
      	Local b2, b3, b4
         b2 = form.Feldwahl.a[selRow, 2].text
         b3 = form.Feldwahl.a[selRow, 3].cb.value
         b4 = form.Feldwahl.a[selRow, 1].oldRowNo
         form.Feldwahl.a[selRow, 2].text = form.Feldwahl.a[selRow - 1, 2].text 
         form.Feldwahl.a[selRow, 3].cb.value = form.Feldwahl.a[selRow - 1, 3].cb.value
         form.Feldwahl.a[selRow, 1].oldRowNo = form.Feldwahl.a[selRow - 1, 1].oldRowNo
         form.Feldwahl.a[selRow - 1, 2].text = b2 
         form.Feldwahl.a[selRow - 1, 3].cb.value = b3
         form.Feldwahl.a[selRow - 1, 1].oldRowNo = b4
			class::Feldwahl_rowSelect(this.parent, selRow - 1)
      endif
      return

*-------------------------------------------------------------------------------
   function Pfeil_down_onClick
   	selRow = form.Feldwahl.selectedRow
   	if selRow < alen(form.myArray, 1)	// schon zuunterst, darum nichts tun
      	Local b2, b3, b4
         b2 = form.Feldwahl.a[selRow, 2].text
         b3 = form.Feldwahl.a[selRow, 3].cb.value
         b4 = form.Feldwahl.a[selRow, 1].oldRowNo
         form.Feldwahl.a[selRow, 2].text = form.Feldwahl.a[selRow + 1, 2].text 
         form.Feldwahl.a[selRow, 3].cb.value = form.Feldwahl.a[selRow + 1, 3].cb.value
         form.Feldwahl.a[selRow, 1].oldRowNo = form.Feldwahl.a[selRow + 1, 1].oldRowNo
         form.Feldwahl.a[selRow + 1, 2].text = b2 
         form.Feldwahl.a[selRow + 1, 3].cb.value = b3
         form.Feldwahl.a[selRow + 1, 1].oldRowNo = b4
			class::Feldwahl_rowSelect(this.parent, selRow + 1)
      endif
      return

endclass

*===============================================================================
 CLASS PH_VisibleCheckBox( oCont ) OF container( oCont ) Custom
*-------------------------------------------------------------------------------
   with(this)
      colorNormal    := "Darkblue/White"
      BorderStyle    := 3  
      height         := 18
      left           := 179
      width          := 76
      onLeftMouseUp  := class::PH_Sichtbar_OnLeftMouseUp
   endwith
   this.cb = new checkbox(this)
   with(this.cb)
      colornormal    := "Darkblue/White"
      FontBold       := false
      BorderStyle    := 3  
      height         := 18
      left           := 20
      width          := 20
      fontSize       := 10
      Group          := true
      text           := ""
      transparent    := true
   endwith    

   procedure PH_Sichtbar_OnLeftMouseUp
   	this.parent.parent.Feldwahl_rowSelect(this.parent.parent, this.rowNr)
      return

 ENDCLASS


*===============================================================================
 class PH_Feldname( oCont ) of TextLabel( oCont ) custom
*-------------------------------------------------------------------------------
   with(this)
      height        := 18
      width         := 149
      left          := 29
      colorNormal   := "Black/white"
      alignVertical := 1      
      font          := "Verdana"
      fontBold      := false
      fontSize      := 9
      borderStyle   := 3
      transparent   := false  
      onLeftMouseUp := class::PH_Feldname_onLeftMouseUp
   endwith

   procedure PH_Feldname_onLeftMouseUp
   	this.parent.parent.Feldwahl_rowSelect(this.parent.parent, this.rowNr)
      return

 endclass
 
*===============================================================================
 class PH_RowHeader( oCont ) of TextLabel( oCont ) custom
*-------------------------------------------------------------------------------
   with(this)
      height        := 18
      alignVertical := 1      
      font          := "Verdana"
      fontBold      := false
      fontSize      := 9
      borderStyle   := 3
      transparent   := false  
      width         := 28
      left          := 0
      colorNormal   := "Black/WhiteSmoke"
      text          := ""
      onLeftMouseUp := class::PH_Rowheader_onLeftMouseUp
   endwith

   procedure PH_Rowheader_onLeftMouseUp
   	this.parent.parent.Feldwahl_rowSelect(this.parent.parent, this.rowNr)
      return

 endclass

*===============================================================================
 class PH_ColHeader( oCont ) of TextLabel( oCont ) custom
*-------------------------------------------------------------------------------
   with(this)
      height        := 18
      width         := 23
      colorNormal   := "black/silver"
      fontSize      := 9
      fontBold      := false
      borderStyle   := 3 	//none
      transparent   := false  
      text          := ""
   endwith     	
 endclass

*===============================================================================
 class PH_ArrowButton( oCont ) of PUSHBUTTON( oCont ) custom
*-------------------------------------------------------------------------------
	with (this)
      systemTheme := true
      height 		:= 30
      width 		:= 30
      left 			:= 300
      top 			:= 178
      text 			:= ""
		fontSize 	:= 11
      borderStyle := 3
   endwith
 endclass